
/**
 * Beschreibt einen Knoten
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Knoten
{
    /** Der Bezeichner des Knotens */
    private String bezeichner;
    /** Die Länge des bisherigen Wegs in Kantenschritten */
    private int länge;
    /** Die Nummer des Vorgängerknotens oder -1 */
    private int vorgänger;
    
    /**
     * Besetzt die Attribute und legt das Knotensymbol an.
     * @param bezeichner Bezeichner
     */
    Knoten (String bezeichner)
    {
        this.bezeichner = bezeichner;
        länge = 0;
        vorgänger = -1;
    }
    
    /**
     * Meldet den Bezeichner des Knotens zurück.
     * @return Bezeichner
     */
    String BezeichnerGeben()
    {
        return bezeichner;
    }
    


    
    /**
     * Setzt die Weglänge
     * @param l die (neue) Länge
     */
    void LängeSetzen(int l)
    {
        länge = l;
    }
    
    /**
     * Meldet die Weglänge zurück.
     * @return Weglänge
     */
    int LängeGeben()
    {
        return länge;
    }
    
    /**
     * Setzt den Vorgänger
     * @param v der Vorgänger
     */
    void VorgängerSetzen(int v)
    {
        vorgänger = v;
    }
    
    /**
     * Meldet den Vorgänger zurück.
     * @return Vorgänger
     */
    int VorgängerGeben()
    {
        return vorgänger;
    }
}
