import java.util.ArrayList;
/**
 * Lösung Kapitel 1.9 - Aufgabe 5: Klasse Lauflängencodierung zur Umwandlung eines Pixeldarstellung eines Bildes
 * in eine Lauflängencodierung und umgekehrt
 * 
 * @author Peter Brichzin
 * @version 1.0
 */
public class Lauflängencodierung 
{
    /**  Speicherung des Pixelbilds als zweidimensionale Arraylist (Matrix):
     *   eine ArrayList mit 15 Elementen (Zeilen) in der wiederum 
     *   eine ArrayList mit 24 Elementen (Spalten) mit je einem Charakter als Eintrag gespeichert ist.
     */
    private ArrayList<ArrayList<Character>> vorlagePixelbildAlsMatrix;
    private ArrayList<ArrayList<Character>> ergebnisPixelbildAlsMatrix;
    /**  Speicherung des Pixelbilds als zweidimensionale Arraylist (Matrix):
     *   eine ArrayList mit 15 Elementen (Zeilen) in der wiederum 
     *   eine ArrayList mit einer passenden Anzahl an Elementen (Spalten) mit 
     *   der Farbe und der Anzahl der Pixel mit gleicher Farbe als Zeichenkette 
     *   gespeichert ist, z. B. "B,8" für 8 blaue Pixel (siehe auch Lehrtext).
     */
    private ArrayList<ArrayList<String>> lauflängencodierung;

    /**
     * Begrüßung nach Erzeugen eines Objekts und Initialisierung der ArrayLists
     */
    Lauflängencodierung()
    {
        System.out.println("Herzlich Willkommen");
        System.out.println("Über die Methode DeutschlandflaggeInMatrixSpeichern bzw. ");
        System.out.println("FrankreichflaggeInMatrixSpeichern kann eine Flagge als Matrix gespeichert werden.");

        System.out.println("Über die Methode LauflängencodierungAusMatrixErstellen wird die passende Lauflängencodierung erstellt.");

        System.out.println("Ihre Aufgabe ist es über die Methode MatrixAusLauflängencodierungErstellen die ");
        System.out.println("(verlustfrei) komprimierten Daten wieder in Ihre Ausgangsdarstellung zurückzuverwandeln.");

        vorlagePixelbildAlsMatrix = new ArrayList<>();
        ergebnisPixelbildAlsMatrix = new ArrayList<>();
        lauflängencodierung = new ArrayList<>();
        //lauflängenCodierungAnzahlGleicheFarbe = new ArrayList<Integer> ();

   }

    /**
     * Methode LauflängencodierungAusMatrixErstellen erstellt aus einem als Matrix gespeicherten 
     * Pixelbild die Lauflängencodierung
     *
     */
    void LauflängencodierungAusMatrixErstellen()
    {
        // temporäre Variablen
        ArrayList<String>  zeileneintragLauflängencodierung;

        char aktuelleFarbe;
        int anzahl;

        // Initialisierung auf eine leere Liste;
        lauflängencodierung = new ArrayList<>();

        // Wiederholung Zeile für Zeile
        for(int y=0; y<15; y = y+1) 
        {
            zeileneintragLauflängencodierung = new ArrayList<>();
            aktuelleFarbe = vorlagePixelbildAlsMatrix.get(y).get(0);
            anzahl = 1;

            // geschachtelte Wiederholung Spalte für Spalte
            for(int x=1; x<24; x = x+1) 
            {
                if(aktuelleFarbe == vorlagePixelbildAlsMatrix.get(y).get(x) )
                {
                    anzahl = anzahl + 1;
                }
                else
                {
                    zeileneintragLauflängencodierung.add(aktuelleFarbe + "," +  anzahl);
                    aktuelleFarbe = vorlagePixelbildAlsMatrix.get(y).get(x);
                    anzahl = 1;
                }
            }
            zeileneintragLauflängencodierung.add(aktuelleFarbe + "," +  anzahl);
            lauflängencodierung.add(zeileneintragLauflängencodierung);
        }
        LauflängencodierungAusgeben();
    }

    /**
     * Methode MatrixAusLauflängencodierungErstellen erstellt aus einem als Lauflängencodierung gespeicherten 
     * Pixelbild ein Bild codiert Pixel für Pixel in dem Attribut ergebnisPixelbildAlsMatrix
     *
     */
    void MatrixAusLauflängencodierungErstellen()
    {
        // temporäre Variablen
        ArrayList<String>  zeileneintragLauflängencodierung;
        char aktuelleFarbe;
        String aktuelleAnzahlGleicherZeichenAlsText; //dieser Zwischenschritt ist nötig, da die Anzahl als Zeichenkette gespeichert ist
        int aktuelleAnzahlGleicherZeichen;
        
        int eintragInZeile; //Index des Eintrags in der Zeile
        
         // Hinweis zum Auslesen der Farbe und der Länge aus der gespeicherten Zeichnkette:
         // aktuelleFarbe = zeileneintragLauflängencodierung.get(eintragInZeile).charAt(0);
        // aktuelleAnzahlGleicherZeichenAlsText = zeileneintragLauflängencodierung.get(eintragInZeile).substring(2);
        // aktuelleAnzahlGleicherZeichen = Integer.parseInt(aktuelleAnzahlGleicherZeichenAlsText);
        
        ArrayList<Character> aktuelleErgebniszeile;

        // Initialisierung auf eine leere Liste;
        ergebnisPixelbildAlsMatrix = new ArrayList<>();

        // TODO
        // TODO
        // TODO
        
        
        
        MatrixAusgeben(ergebnisPixelbildAlsMatrix);
    }


    /**
     * Methode DeutschlandflaggeInMatrixSpeichern speichert die deutsche Flagge als Pixelbild 
     * in dem Attribut vorlagePixelbildAlsMatrix
     *
     */
    void DeutschlandflaggeInMatrixSpeichern()
    {
        // ggf. altes Bild entfernen
        vorlagePixelbildAlsMatrix.clear();
        for(int y=0; y<15; y = y+1) 
        {
            vorlagePixelbildAlsMatrix.add(new ArrayList<Character>());
        }
        //schwarz
        for(int y=0; y<5; y = y+1) 
        {
            for(int x=0; x<24; x = x+1) 
            {
                vorlagePixelbildAlsMatrix.get(y).add('S');
            }
        }

        //rot
        for(int y=5; y<10; y = y+1) 
        {
            for(int x=0; x<24; x = x+1) 
            {
                vorlagePixelbildAlsMatrix.get(y).add('R');
            }
        }

        //gold bzw. gelb; ist hier möglich, da es keine Verwechslung mit grün gibt
        for(int y=10; y<15; y = y+1) 
        {
            for(int x=0; x<24; x = x+1) 
            {
                vorlagePixelbildAlsMatrix.get(y).add('G');
            }
        }

        MatrixAusgeben(vorlagePixelbildAlsMatrix);
    }

    /**
     * Methode FrankreichflaggeInMatrixSpeichern speichert die französische Flagge als Pixelbild 
     * in dem Attribut vorlagePixelbildAlsMatrix
     *
     */
    void FrankreichflaggeInMatrixSpeichern()
    {
        // ggf. altes Bild entfernen
        vorlagePixelbildAlsMatrix.clear();
        for(int y=0; y<15; y = y+1) 
        {
            vorlagePixelbildAlsMatrix.add(new ArrayList<Character>());
        }

        //Zeilenweiser Aufbau
        for(int y=0; y<15; y = y+1) 
        {
            // blau
            for(int x=0; x<8; x = x+1) 
            {
                vorlagePixelbildAlsMatrix.get(y).add('B');
            }
            //weiß
            for(int x=8; x<16; x = x+1) 
            {
                vorlagePixelbildAlsMatrix.get(y).add('W');
            }
            // rot
            for(int x=16; x<24; x = x+1) 
            {
                vorlagePixelbildAlsMatrix.get(y).add('R');
            }
        }

        MatrixAusgeben(vorlagePixelbildAlsMatrix);
    }

    /**
     * Methode MatrixAusgeben gibt Pixel für Pixel auf der Konsole die gespeicherte Farbe aus.
     *
     * @param pixelbildAlsMatrix ein 24x15 Pixel gespeichert als ArrayList<ArrayList<Character>>
     */
    private void MatrixAusgeben(ArrayList<ArrayList<Character>> pixelbildAlsMatrix)
    {
        //Unterteilung in einstellige Zeilennummern ...
        for(int y=0; y<10; y = y+1) 
        {
            System.out.println("Zeile " + y + " : " + pixelbildAlsMatrix.get(y));
        }

        // .. und zweistellige Zeilennummern
        for(int y=10; y<15; y = y+1) 
        {
            System.out.println("Zeile " + y + ": " + pixelbildAlsMatrix.get(y));
        }

    }

    /**
     * Methode LauflängencodierungAusgeben gibt die i Attribut lauflängencodierung gespeicherte 
     * Lauflängencodierung zeilenweise aus.
     *
     */
    private void LauflängencodierungAusgeben()
    {
        for(int y=0; y<15; y = y+1) 
        {
            String zeile;
            zeile = "";
            for(String s: lauflängencodierung.get(y))
            {
                zeile = zeile + s + "  ";
            }
            System.out.println(zeile);
        }

    }

}
